// DFItemHandling.cpp: Implementierung der Klasse CDFItemHandling.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "DFItemHandling.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Konstruktion/Destruktion
//////////////////////////////////////////////////////////////////////

CDFItemHandling::CDFItemHandling(NodeTypeID _type) : CDFItemBase(_type)
{

}

CDFItemHandling::~CDFItemHandling()
{

}

int CDFItemHandling::Modify(CModifyData &modifyData)
{
	int i;
	unsigned int offs = modifyData.offsFlash, offsChild;
	TBedien bedien;
	CDFItemBase *item;
	
	// Daten von Konfig Root einlesen
	TBKonfigRoot &root = *(TBKonfigRoot*)&modifyData.file->m_flash[modifyData.offsFlash - FLASH_KONFIG_START];
	ChangeOrderLong((unsigned char*)&root.P);
	offs += sizeof(TBKonfigRoot);
	
	// Daten aller Eintraege einlesen
	for (i=0; i < (int)root.EintragCnt; i++) {
		
		// Pointer des Eintrags berechnen
		offsChild = root.P + i * sizeof(unsigned int);	
		
		offsChild = *(unsigned int*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];
		ChangeOrderLong((unsigned char*)&offsChild);
		
		// Daten von Bedien - Struktur fuer Klassenerzeugung einlesen
		bedien = *(TBedien*)&modifyData.file->m_flash[offsChild - FLASH_KONFIG_START];
		
		switch(bedien.Typ) {
			
		case TB_MENUE: { 
				item = new CDFItemMenu();
				break;}
			
		case TB_DATENSATZ: {
				item = new CDFItemInputChain();
				break;}
			
		default:
#ifdef _WIN32
			ASSERT(0);
#endif
			break;
		}

		LinkEndChild(item);
		modifyData.offsFlash = offsChild;
		item->Modify(modifyData);
	}

	// Adresse zurueckkonvertieren
	ChangeOrderLong((unsigned char*)&root.P);
	
	return 1;
}
